<template>
  <div class="spot-price">
    <Header
      :spotNumber="spotOrderByCarrier.number"
      :spotType="spotAuctionByCarrier.type"
    />
    <div v-if="isDownGrade" class="spot-price__content">
      <span
        v-once
        :class="[
          'spot-price__content-bid',
          chosenStyle,
          winStyle,
          loseStyle,
          noBidsStyle,
          cancelledStyle,
        ]"
      >
        <span v-if="spotOrderByCarrier.chosenCarrier">{{ ChosenCarrierCurrentPrice }}</span>
        <span v-else>{{ currentPriceWithVat }}</span>
        <i class="icon question" />
      </span>
      <div class="spot-price__content-tax">
        {{ vatAmountText }}
      </div>
      <div
        v-if="(isAuction || isInProccess) && isWin"
        class="spot-price__state success"
      >
        Ваша ставка — лучшая
      </div>
      <div
        v-if="(isAuction || isInProccess) && isLosing"
        class="spot-price__state loser"
      >
        Вашу ставку перебили
      </div>
      <div v-if="isAuction || isInProccess" class="spot-price__step">
        Шаг {{ biddingStepWithVat }} ({{ biddingStepVatAmount }})
      </div>
    </div>
    <div
      v-if="isBlind && auctionCurrentPrice"
      class="spot-price__content"
    >
      <span class="spot-price__content-bid">
        {{ currentPriceBlindAuction }}
        <i class="icon question" />
      </span>
      <div class="spot-price__content-tax">
        {{ vatAmountText }}
      </div>
    </div>
    <div v-if="isFirstApprove" class="spot-price__content">
      <span
        class='spot-price__content-bid'
      >
        {{ currentPriceWithVat }}
        <i class="icon question" />
      </span>
      <div class="spot-price__content-tax">
        {{ vatAmountText }}
      </div>
    </div>
    <Controls :spotType="spotAuctionByCarrier.type" />
    <Indicators
      :spotOrderStatus="spotOrderByCarrier.spotOrder.orderStatus"
      :spotViewsCount="spotAuctionByCarrier.viewsCount"
      :spotBidsCount="spotAuctionByCarrier.auctionInfo.bidsCount"
      :spotEndTime="spotOrderByCarrier.endPlanDt"
      :spotAuctionInfoCurrentState="spotOrderByCarrier.auctionCurrentInfo.currentState"
      :spotType="spotAuctionByCarrier.type"
    />
  </div>
</template>

<script>
import Header from './header'
import Controls from './controls'
import Indicators from './indicators'
import transformer from '../../../transformer'
import { mapGetters } from 'vuex'
import { formatNumber } from 'common-components/src/helpers/common'

export default {
  mixins: [transformer],
  components: {
    Header,
    Controls,
    Indicators,
  },
  computed: {
    ...mapGetters({
      spotOrderByCarrier: 'spot/spotOrderByCarrier',
      spotAuctionByCarrier: 'spot/spotAuctionByCarrier',
    }),
    isAuction() {
      return this.spotAuctionByCarrier.auctionStatus === 'AUCTION'
    },
    isDownGrade() {
      return this.spotAuctionByCarrier.type === 'DOWNGRADE'
    },
    isBlind() {
      return this.spotAuctionByCarrier.type === 'BLIND'
    },
    isFirstApprove() {
      return this.spotAuctionByCarrier.type === 'FIRST_APPROVE'
    },
    isInProccess() {
      return this.spotAuctionByCarrier.auctionStatus === 'IN_PROCCESS'
    },
    isCancelled() {
      return this.spotAuctionByCarrier.auctionStatus === 'CANCELLED'
    },
    isWin() {
      return this.spotAuctionByCarrier.auctionInfo.currentState === 'WIN'
    },
    isLosing() {
      return this.spotAuctionByCarrier.auctionInfo.currentState === 'LOSING'
    },
    isChosenByCarrier() {
      return this.spotOrderByCarrier.spotOrder.isCarrierChosen
    },
    currentPriceWithVat() {
      return this.auctionCurrentPrice
        ? formatNumber((this.auctionCurrentPrice + this.auctionVat) / 100) + ' ₽'
        : '–'
    },
    biddingStepWithVat() {
      return this.auctionBiddingStep
        ? formatNumber((this.auctionBiddingStep + this.auctionBiddingStepVatAmount) / 100) + ' ₽'
        : '–'
    },
    biddingStepVatAmount() {
      return this.auctionBiddingStepVatAmount
        ? 'в том числе НДС ' + formatNumber(this.auctionBiddingStepVatAmount / 100) + ' ₽'
        : 'НДС не облагается'
    },
    currentPriceBlindAuction() {
      return this.auctionCurrentPrice
        ? formatNumber(this.auctionCurrentPrice / 100 + (this.auctionVat ? this.auctionVat / 100 : 0)) + ' ₽'
        : '–'
    },
    ChosenCarrierCurrentPrice() {
      return this.spotOrderByCarrier.chosenCarrier.carrierPrice
          ? formatNumber(this.spotOrderByCarrier.chosenCarrier.carrierPrice  / 100 + (this.auctionVat ? this.auctionVat / 100 : 0)) + ' ₽'
        : '–'
    },
    auctionCurrentPrice() {
      return this.spotAuctionByCarrier.auctionInfo.currentPrice;
    },
    auctionVat() {
      return this.spotAuctionByCarrier.auctionInfo.vatAmount;
    },
    auctionBiddingStep() {
      return this.spotAuctionByCarrier.auctionInfo.biddingStep;
    },
    auctionBiddingStepVatAmount() {
      return this.spotAuctionByCarrier.auctionInfo.biddingStepVatAmount;
    },
    chosenStyle() {
      return this.isChosenByCarrier ? '-caribbean-green' : ''
    },
    winStyle() {
      return (this.isWin && this.isSpotListActual) ||
        (!this.isCancelled &&
          this.isChosenByCarrier &&
          this.isSpotListCompleted)
        ? '-caribbean-green'
        : ''
    },
    loseStyle() {
      return !this.isCancelled && this.isLosing && !this.isChosenByCarrier
        ? '-light-raspberry-red'
        : ''
    },
    noBidsStyle() {
      return !this.isCancelled &&
        this.spotOrderByCarrier.auctionCurrentInfo.currentState === 'NO_BIDS'
        ? '-gray-slate'
        : ''
    },
    cancelledStyle() {
      return this.isCancelled ? '-cobalt-black' : ''
    },
    vatAmountText() {
      return this.auctionVat
        ? `В том числе НДС ${formatNumber(this.auctionVat / 100)} ₽`
        : 'НДС не облагается'
    },
    isSpotListActual() {
      return this.$route.path === '/spot-list'
    },
    isSpotListCompleted() {
      return this.$route.path === '/spot-list-completed'
    },
  },
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
.spot-price {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  border-bottom: 1px solid $lavender;
  padding: 20px 20px 16px;
  .loser {
    color: $color-error;
    margin-top: 10px;
  }
  .success {
    color: $green-craiola;
  }
  &__step {
    font-size: 14px;
    line-height: 18px;
    letter-spacing: 0.2px;
    color: $gray-slate;
    text-align: center;
    margin-top: 10px;
  }
  &__content {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 100%;
    padding: 20px 10px 0 10px;
    &-bid {
      position: relative;
      display: flex;
      justify-content: center;
      align-items: center;
      font-weight: bold;
      font-size: 24px;
      line-height: 36px;
      letter-spacing: 0.2px;
      color: $color-text-base;
      mix-blend-mode: normal;
      opacity: 0.9;
      & span {
        margin-left: 10px;
      }
      & .question {
        position: absolute;
        font-size: 12px;
        color: $gray-slate;
        right: -20px;
        cursor: pointer;
      }
    }
    &-tax {
      font-size: 10px;
      line-height: 12px;
      letter-spacing: 0.4px;
      color: $gray-slate;
    }
    &-links {
      margin-top: 16px;
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.4px;
      color: $color-blue-navy-blue;
      a {
        cursor: pointer;
      }
    }
    .warning {
      color: $color-error;
      padding: 15px 0;
    }
    .success {
      color: $green-craiola;
      padding: 15px 0;
    }
    &__state {
      padding: 10px 0;
      letter-spacing: 0.2px;
      font-size: 14px;
    }
  }
}
</style>
